//Copy2.cc by Jason Winnebeck v1.0  3/30/99
//website: http://skyscraper.fortunecity.com/solarcity/552/

//Copies srcfile into destfile using C++ streams.
#include <iostream.h> //for cout
#include <fstream.h>  //for ifstream and ofstream
#include <conio.h>    //for gotoxy (fluff output)

int main(int argc, char *argv[]) { //Accept commandline parameters
  if (argc != 3) { //if there aren't 3 parameters (progname, srcname, destname
    cout << "copy2 <src file> <dest file>" << endl; //display help
    return -1; //return and error if the calling program checks
  }

  ifstream srcfile(argv[1], ios::bin | ios::in);
   //Declare a file to be read from.  Open binary mode
  ofstream destfile(argv[2], ios::bin | ios::out);
   //Declare a file to be written to.  Open binary mode

  //The hard drive reads in blocks, many bytes at a time.
  //If you were to copy a handwritten letter, would it be faster to look at
  // each individual letter and write it, look write, or memorize a sentence
  // and write?  This works on the same principle.
  unsigned int BUFFER_SIZE = 32767; //How big is the initial buffer?
  char *temp = new char[BUFFER_SIZE]; //reserve memory for the buffer
  srcfile.seekg(0, ios::end); //go to 0 bytes from the end of file
  unsigned int filesize = srcfile.tellg();
    //How far from the start is the file pointer?  This is the filesize
  srcfile.seekg(0); //go back to start

  cout << "Copying " << argv[1] << " of " << filesize << " bytes to " << argv[2] << endl;
    //Display what we are doing

  while (srcfile && (filesize != srcfile.tellg())) {
    //Until all of the file is copied or an error
    if ((srcfile.tellg() + BUFFER_SIZE) > filesize) {//Don't overflow the file!
      delete[] temp;                   //Get rid of old buffer
      BUFFER_SIZE = filesize - srcfile.tellg();//Exact resize
      temp = new char[BUFFER_SIZE];    //Allocate new buffer
    }
    srcfile.read(temp, BUFFER_SIZE);   //read buffer amount
    destfile.write(temp, BUFFER_SIZE); //write buffer amount
    //The next lines are just "fluff" output showing the progess
    cout << "Bytes written: " << srcfile.tellg() << "  out of: " << filesize << endl;
    for (int d = 0; d <= int(double(srcfile.tellg())/filesize/2.0*100.0); d++)
      cout << '*';
    cout << int(double(srcfile.tellg())/filesize*100.0) << "%" << endl;
    gotoxy(1, wherey() - 2);
    //End of "fluff" output
  }

  delete[] temp;     //Return buffer memory to system
  srcfile.close();   //Close files when we're done!!!
  destfile.close();

  gotoxy(1, wherey() + 2); //Move cursor so DOS displays C:\> prompt correctly
  return 0; //no errors
}
